## $Id: htmlwidget.py 11949 2014-11-13 14:40:27Z henrik $
##
## Copyright (C) 2012 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""A widget that renders a persistent object title inside an anchor element
referring to the object.
"""
import grok
from zope.formlib.widget import DisplayWidget


class HREFDisplayWidget(DisplayWidget):

    def __call__(self):
        if self._renderedValueSet():
            title = getattr(self._data, 'title', '')
            name = getattr(self._data, '__name__', '')
            if not name:
                return ''
            url = grok.url(self.request, self._data)
        else:
            return ''
        return '<a href="%s">%s - %s</a>' % (url, name, title)
